subroutine fmin(string %list,vector xvarinit)

%data = "matdata"
%data = @makevalidname(%data)
group {%data}

'Generate the transformed (in)dependent variables for analysis.
     !n = @wcount(%list)
     %dep = @word(%list,1)
     if !check = 1 then
          series {%dep}_y = @cumsum({%dep})
        else
          series {%dep}_y = {%dep}
     endif
     {%data}.add {%dep}_y
     series gbass_time = @cumsum(1)
     {%data}.add gbass_time
       if !n>1 then
          for !i = 2 to !n
           !k = !i-1
           %ser = @word(%list,!i)
           series {%ser}_x!k = log({%ser}/xvarinit(!i-1))
           {%data}.add {%ser}_x!k
           if !check = 0 then
              series {%ser}_xd!k = @pc({%ser})/100
              {%ser}_xd!k(1) = 0
              {%data}.add {%ser}_xd!k
           endif
          next
       endif

'Create the mapping function(s)
%map = %data+"(:,2)"
%mapd = "1"
if !n>1 then
   !j=1
   while !j<!n
    !j=!j+1
    %map = %map + "+" + "c("+@str(!j+2)+")*"+%data+"(:,"+@str(!j+1)+")"
      if !check=0 then
       %mapd = %mapd + "+" + "c("+@str(!j+2)+")*"+%data+"(:,"+@str(!n+!j-1)+")"
     endif
   wend
endif

'Final formula for MATLAB
if !check=1 then
   %error = "minerr= @(c) ("+%data+"(:,1)-(c(3)*(1-exp(-(" + %map + ")*(c(1)+c(2))))./((c(2)/c(1))*exp(-(" +%map + ")*(c(1)+c(2)))+1)));"
else
   %error = "minerr= @(c) ("+%data+"(:,1)-((((c(1)+c(2))^2)/c(1))*c(3)*("+%mapd+").*(exp(-(" + %map + ")*(c(1)+c(2))))./((c(2)/c(1))*exp(-(" +%map + ")*(c(1)+c(2)))+1).^2));"
endif

'Specify the values of input arguments for MATLAB optimization
!size = @wcount(%list)-1
vector(!size+3) begin
vector(!size+3) lbound = -1e+06
vector(!size+3) ubound = 1e+06

  begin(1) = 0.001
  begin(2) = 0.1
  begin(3) = @sum({%dep})

  lbound(1) = 0
  lbound(2) = 0
  lbound(3) = begin(3)

  ubound(1) = 1
  ubound(2) = 1

vector(!size+3) start

'Send the data to MATLAB
call matsend({%data},begin,lbound,ubound,%error,start)

'Get rid of the unnecessary stuff
if !n>1 then
  delete {%data} {%dep}_y gbass_time begin lbound ubound
     for !r = 1 to !n-1
       %ser = @word(%list,!r+1)
       delete {%ser}_x!r 
         if !check=0 then
           delete {%ser}_xd!r
         endif
    next
else
  delete {%data} {%dep}_y gbass_time begin lbound ubound
endif

endsub

'*********************************************************************************************************************************************

subroutine local matsend(group data,vector beg,vector lb,vector ub,string %func,vector start)

xopen(type=m)

%dname = data.@name
xput(name=%dname) data
xput beg lb ub

'Lsqnonlin solver is preferred
%com = "[c fval] = lsqnonlin(minerr,begin,lbound,ubound)"

'Run the commands in MATLAB
xrun %func
xrun %com

'Get the optimization results
xget(type=vector, name=cvec) c
start = cvec

'Slightly move away from the optimum point
start = (1+@rnd/100)*start

xclose

endsub
